/**
 * $Id: bmpfont.h,v 1.3 2003/04/02 15:10:12 i Exp $
 *
 * Copyright (C) shinichiro.h <g940455@mail.ecc.u-tokyo.ac.jp>
 *  http://user.ecc.u-tokyo.ac.jp/~g940455/wp/
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef bmpfont_h_
#define bmpfont_h_

#include <SDL.h>

#include <string>

class BMPFont {
public:
	explicit BMPFont(const std::string& filename);

	void render(const char* str, struct SDL_Surface* surf, int x, int y);
	void render(const std::string& str, struct SDL_Surface* surf,
				int x, int y) {
		render(str.c_str(), surf, x, y);
	}

	/// adhoc $B$+$D=E$$(B
	void renderColored(const char* str, struct SDL_Surface* surf,
					   int x, int y, Uint32 color);
	void renderColored(const std::string& str, struct SDL_Surface* surf,
					   int x, int y, Uint32 color) {
		renderColored(str.c_str(), surf, x, y, color);
	}

	int height() const;
	int width(int num) const;

private:
	struct SDL_Surface* font_;
	std::string sample_;

private:
	static const double dotPerChar_;
	static const int charWidth_;
	static const int charHeight_;

};

#endif // ! bmpfont_h_

