/**
 * $Id: bpo.h,v 1.13 2003/07/24 10:53:10 i Exp $
 *
 * Copyright (C) shinichiro.h <g940455@mail.ecc.u-tokyo.ac.jp>
 *  http://user.ecc.u-tokyo.ac.jp/~g940455/wp/
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef bpo_h_
#define bpo_h_

#include "singleton.h"

#include <memory>
#include <string>

struct BPOImpl;

class BPO : public Singleton<BPO, CanNewPolicy> {
public:
	BPO(int argc, char* argv[]);
	void run();

public:
	static class Resource& rc();

	static struct SDL_Surface* getScreen();
	static struct SDL_Surface* getSurface();

	static bool shouldSkip();

	static class Input* getInput();

	static class BulletMLParser* getNormalBullet();
	static class BulletMLParser* getEasyBullet();
	static class BulletMLParser* getHardBullet();

	static void resetColors();

	static class BMPFont* getBMPFont();
	//static struct Kanji_Font* getBDFFont();

	static void timerStart();
	static int getFps();

	static const class Music* getMusic();

	static void setClearMode(int mode);

	static void setBulletMode();

private:
	std::auto_ptr<BPOImpl> pimpl_;
	static BPOImpl* spimpl_;

};

#endif // ! bpo_h_

