/**
 * $Id: bullet.cc,v 1.3 2003/04/05 06:54:19 i Exp $
 *
 * Copyright (C) shinichiro.h <g940455@mail.ecc.u-tokyo.ac.jp>
 *  http://user.ecc.u-tokyo.ac.jp/~g940455/wp/
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */


#include "bullet.h"

#include "bullet_command.h"

Bullet::Bullet(class Game* game, class BulletMLState* state,
			   Num x, Num y, Num sx, Num sy)
	: Charactor::HaveSpeed(x, y, sx, sy), dead_(false)
{
	const std::vector<BulletMLNode*>& acts = state->getNode();
	std::vector<BulletMLNode*>::const_iterator ite;
	for (ite = acts.begin(); ite != acts.end(); ite++) {
	const BulletMLNode* act = *ite;
		if (act->findNode(BulletMLNode::fire)) break;
		if (act->findNode(BulletMLNode::fireRef)) break;
		if (act->findNode(BulletMLNode::actionRef)) break;
	}
	canFire_ = (ite != acts.end());

	runner_.reset(new BulletCommand(game, state, this));
}

void Bullet::event() {
	if (runner_.get()) {
		runner_->run();
		if (runner_->isEnd()) {
			runner_.reset(0);
		}
	}
	move();
}


