/**
 * $Id: bullet.h,v 1.2 2003/01/01 15:59:44 i Exp $
 *
 * Copyright (C) shinichiro.h <g940455@mail.ecc.u-tokyo.ac.jp>
 *  http://user.ecc.u-tokyo.ac.jp/~g940455/wp/
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef bullet_h_
#define bullet_h_

#include "charactor.h"

#include <memory>

class Bullet : public Charactor::HaveSpeed, public Charactor::CanBuzz {
public:
	Bullet(class Game* game, class BulletMLState* state,
		   Num x, Num y, Num sx, Num sy);

	void setDead() { dead_ = true; }
	bool isDead() const { return dead_; }

	bool canFire() const { return canFire_; }

	void event();

private:
	std::auto_ptr<class BulletMLRunner> runner_;

	bool dead_;
	bool canFire_;

};

#endif // ! bullet_h_



