/**
 * $Id: bullet_command.h,v 1.2 2003/07/24 10:53:10 i Exp $
 *
 * Copyright (C) shinichiro.h <g940455@mail.ecc.u-tokyo.ac.jp>
 *  http://user.ecc.u-tokyo.ac.jp/~g940455/wp/
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef bullet_command_h_
#define bullet_command_h_

#include "bulletml/bulletmlrunner.h"

class BulletCommand : public BulletMLRunner {
public:
	BulletCommand(class Game* game, class BulletMLState* state,
				  class Bullet* enemy);

public:
	virtual double getBulletDirection();
	virtual double getAimDirection();
	virtual double getBulletSpeed();
	virtual double getDefaultSpeed();
	virtual double getRank();
	virtual void createSimpleBullet(double direction, double speed);
	virtual void createBullet(BulletMLState* state,
							  double direction, double speed);
	virtual int getTurn();
	virtual void doVanish();

	virtual void doChangeDirection(double dir);
	virtual void doChangeSpeed(double spd);
	virtual void doAccelX(double x);
	virtual void doAccelY(double y);
	virtual double getBulletSpeedX();
	virtual double getBulletSpeedY();

private:
	class Game* game_;

	class Bullet* bullet_;

	double shotSpeedRatio_;

};

#endif // ! bullet_command_h_
