/**
 * $Id: bulletml_holder.h,v 1.5 2003/07/24 10:53:10 i Exp $
 *
 * Copyright (C) shinichiro.h <g940455@mail.ecc.u-tokyo.ac.jp>
 *  http://user.ecc.u-tokyo.ac.jp/~g940455/wp/
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef bulletml_holder_h_
#define bulletml_holder_h_

#include <vector>
#include <string>
#include <map>

class BulletMLHolder {
public:
	BulletMLHolder();
	~BulletMLHolder();

	class BulletMLParser* getNormalBullet();
	class BulletMLParser* getEasyBullet();
	class BulletMLParser* getHardBullet();

	void setMode(std::string mode);

private:
	typedef std::map<std::string, class BulletMLParser*> Name2Bullet_;
	typedef std::map<std::string, Name2Bullet_> Mode2Bullets_;
	typedef std::vector<class BulletMLParser*> Bullets_;
	Bullets_ normal_;
	Bullets_ easy_;
	Bullets_ hard_;
	Mode2Bullets_ mode2normals_;
	Mode2Bullets_ mode2easys_;
	Mode2Bullets_ mode2hards_;
	Bullets_ deleteList_;

	void setMode_(const Name2Bullet_& inb, Bullets_* outb);

private:
	void loadDir(const std::string& dirname, Name2Bullet_& bullets);

};

#endif // ! bulletml_holder_h_

