/**
 * $Id: charactor.h,v 1.4 2002/12/26 19:58:51 i Exp $
 *
 * Copyright (C) shinichiro.h <g940455@mail.ecc.u-tokyo.ac.jp>
 *  http://user.ecc.u-tokyo.ac.jp/~g940455/wp/
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef charactor_h_
#define charactor_h_

#include "config.h"

namespace Charactor {
	class HavePoint {
	protected:
		Num x_, y_;

	public:
		HavePoint() {}
		HavePoint(Num x, Num y) : x_(x), y_(y) {}
		Num x() const { return x_; }
		Num y() const { return y_; }
		int xi() const { return static_cast<int>(x_); }
		int yi() const { return static_cast<int>(y_); }
		void setX(Num x) { x_ = x; }
		void setY(Num y) { y_ = y; }

	public:
		Num angle() const;
		Num angle(const HavePoint& p) const;

	};

	class HaveSpeed : public HavePoint {
	protected:
		Num sx_, sy_;

	public:
		HaveSpeed() {}
		HaveSpeed(Num x, Num y, Num sx, Num sy)
			: HavePoint(x, y), sx_(sx), sy_(sy) {}

		Num sx() const { return sx_; }
		Num sy() const { return sy_; }

		void setSpeedX(Num sx) { sx_ = sx; }
		void setSpeedY(Num sy) { sy_ = sy; }

		void move() {
			x_ += sx_;
			y_ += sy_;
		}
	};

	class CanBuzz {
	public:
		CanBuzz() : buzzed_(false) {}

		bool isBuzzed() const { return buzzed_; }
		void setBuzzed() { buzzed_ = true; }

	private:
		bool buzzed_;
	};

};

#endif // ! charactor_h_



