/**
 * $Id: cpuinfo.h,v 1.1 2003/03/30 03:38:55 i Exp $
 *
 * Copyright (C) shinichiro.h <g940455@mail.ecc.u-tokyo.ac.jp>
 *  http://user.ecc.u-tokyo.ac.jp/~g940455/wp/
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef cpuinfo_h_
#define cpuinfo_h_

#include "cpuutil.h"

#include <vector>
#include <utility>

/// cpu ˤƤ٤󷲡貾ۡ
class CpuInfo {
public:
	typedef std::vector<std::pair<Point, Point> > PosSpd;

	/// player 礭
	virtual double getPlayerSize() =0;

	/// player ΰ
	virtual Point getPlayerPnt() =0;

	/// player ®
	virtual double getPlayerSpd() =0;

	/// player ΰưǤɸ͡
	virtual Point getPlayerMaxPnt() =0;

	/// Bullet ΰ֤®پĤä֤
	virtual void getBulletsPosAndSpd(PosSpd& posspd) =0;

	/// FPS
	virtual double getFps() =0;

	/// ߤΥ
	virtual int getTurn() =0;

	/// SPF С饤ɤʤɤ
	virtual double getSpf() {
		return 1.0 / getFps();
	}

};

#endif // ! cpuinfo_h_



