/**
 * $Id: cpuinfo_bpo.h,v 1.1 2003/03/30 03:38:55 i Exp $
 *
 * Copyright (C) shinichiro.h <g940455@mail.ecc.u-tokyo.ac.jp>
 *  http://user.ecc.u-tokyo.ac.jp/~g940455/wp/
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef cpuinfo_bpo_h_
#define cpuinfo_bpo_h_

#include "cpuinfo.h"
#include "game.h"
#include "player.h"

/// BPO $B$N$P$"$$!#(B
class CpuInfoBpo : public CpuInfo {
public:
	CpuInfoBpo(Game* game) : game_(game) {}

	/// player $B$NBg$-$5!#(B($BEv$jH=Dj(B)
	virtual double getPlayerSize() {
		// @todo $B%^%8%C%/%J%s%P!<(B
		return 4;
	}

	/// player $B$N0LCV(B
	virtual Point getPlayerPnt() {
		return Point(game_->getPlayer()->x(), game_->getPlayer()->y());
	}

	/// player $B$NB.EY(B
	virtual double getPlayerSpd() {
		// @todo $B%^%8%C%/%J%s%P!<(B
		return 5 * 62;
	}

	/// player $B$N0\F0$G$-$k:GBg:BI8CM!#(B
	virtual Point getPlayerMaxPnt() {
		return Point(450, 600);
	}

	/// Bullet $B$N0LCV$HB.EY>pJs$r$D$C$3$s$GJV$9!#(B
	virtual void getBulletsPosAndSpd(PosSpd& posspd);

	/// FPS
	virtual double getFps() {
		return 62;
	}

	/// $B8=:_$N%?!<%s?t(B
	virtual int getTurn() {
		return game_->getTurn();
	}

	/// SPF
	virtual double getSpf() {
		return 1.0 / 62;
	}

private:
	Game* game_;

};

#endif // ! cpuinfo_bpo_h_

