/**
 * $Id: enemy.h,v 1.5 2002/12/14 17:07:53 i Exp $
 *
 * Copyright (C) shinichiro.h <g940455@mail.ecc.u-tokyo.ac.jp>
 *  http://user.ecc.u-tokyo.ac.jp/~g940455/wp/
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef enemy_h_
#define enemy_h_

#include "charactor.h"

class Enemy : public Charactor::HavePoint {
	int speed_;

	static Num baseSpeed_;
	static Num centerX_, centerY_;
	static Num ellipseX_, ellipseY_;

public:
	Enemy();

	int speed() const { return speed_; }
	void setSpeed(int speed) { speed_ = speed; }

	static Num baseSpeed() { return baseSpeed_; }
	static void setBaseSpeed(Num baseSpeed) { baseSpeed_ = baseSpeed; }

	static Num centerX() { return centerX_; }
	static void setCenterX(Num centerX) { centerX_ = centerX; }

	static Num centerY() { return centerY_; }
	static void setCenterY(Num centerY) { centerY_ = centerY; }

	static Num ellipseX() { return ellipseX_; }
	static void setEllipseX(Num ellipseX) { ellipseX_ = ellipseX; }

	static Num ellipseY() { return ellipseY_; }
	static void setEllipseY(Num ellipseY) { ellipseY_ = ellipseY; }

};

#endif // ! enemy_h_

