/**
 * $Id: game.h,v 1.12 2003/04/06 13:34:57 i Exp $
 *
 * Copyright (C) shinichiro.h <g940455@mail.ecc.u-tokyo.ac.jp>
 *  http://user.ecc.u-tokyo.ac.jp/~g940455/wp/
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef game_h_
#define game_h_

#include "config.h"
#include "charactor.h"

#include <memory>
#include <vector>
#include <utility>

struct GameImpl;

class Game {
public:
	Game();
	void run();
	~Game();

	void reserveShot(class BulletMLParser* bulletml, int turn);

	void addShot(Num x, Num y, double dir, double spd);
	void addBullet(class BulletMLState* state,
				   Num x, Num y, double dir, double spd);

	int getTurn() const;
	int getRank() const;

	class Player* getPlayer();
	std::vector<Charactor::HaveSpeed*> getBullets();

	bool isEnd() const;

	std::auto_ptr<class Resource> getResult() const;
	std::auto_ptr<class BonusMgr> getBonus() const;
	std::auto_ptr<class Music> getMusic() const;

private:
	GameImpl* pimpl_;

};

#endif // ! game_h_

