/**
 * $Id$
 *
 * Copyright (C) shinichiro.h <g940455@mail.ecc.u-tokyo.ac.jp>
 *  http://user.ecc.u-tokyo.ac.jp/~g940455/wp/
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

/// WCXeBbNi
/**
 * {Iɂ͔bp
 * WCXeBbNĂ邩ȂCɂɎg
 */

#ifndef joystickmgr_h_
#define joystickmgr_h_

#include "cpputil.h"

#include <vector>
#include <iostream>

#include <singleton.h>

#include <SDL.h>

class Joystick {
public:
	explicit Joystick(int index) {
		joystick_ = SDL_JoystickOpen(index);
		if (joystick_ != 0) std::cout << "success open joystick " <<
								index << std::endl;
		else std::cout << "failed open joystick " << index << std::endl;
	}
	~Joystick() {
		if (isInited()) SDL_JoystickClose(joystick_);
	}

	bool isInited() const { return joystick_ != 0; }

	Sint16 axis(int axis) const {
		return SDL_JoystickGetAxis(const_cast<SDL_Joystick*>(joystick_), axis);
	}
	Sint16 axisX() const {
		return axis(0);
	}
	Sint16 axisY() const {
		return axis(1);
	}

	Uint8 getButton(int button) const {
		return 1 == SDL_JoystickGetButton(const_cast<SDL_Joystick*>(joystick_),
										  button);
	}

private:
	SDL_Joystick* joystick_;

};

class JoystickMgr : public Singleton<JoystickMgr> {
public:
	/**
	 * @return
	 * G[̏ꍇ 0 ԂB
	 * ́AJoystick  open łȂƂ邩Ǝv
	 */
	Joystick* getJoystick(int index) {
		checkInit();

		if (!inited_) return 0;

		checkJoysticksSize(index);

		if (joysticks_[index] == 0) {
			joysticks_[index] = new Joystick(index);
		}

		if (joysticks_[index]->isInited()) {
			return joysticks_[index];
		}
		else {
			return 0;
		}
	}

	~JoystickMgr() {
		delete_clear(joysticks_);
	}

private:
	void checkJoysticksSize(unsigned int index) {
		if (joysticks_.size() <= index) {
			joysticks_.resize(index+1, 0);
		}
	}

	void checkInit() {
		inited_ = true;
		if (!SDL_WasInit(SDL_INIT_JOYSTICK)) {
			SDL_InitSubSystem(SDL_INIT_JOYSTICK);
			std::cout << "joystick inited." << std::endl;
		}
	}

private:
	bool inited_;
	std::vector<Joystick*> joysticks_;

};

#endif // ! joystickmgr_h_
