/**
 * $Id: message.cc,v 1.3 2003/04/06 13:34:57 i Exp $
 *
 * Copyright (C) shinichiro.h <g940455@mail.ecc.u-tokyo.ac.jp>
 *  http://user.ecc.u-tokyo.ac.jp/~g940455/wp/
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include "message.h"
#include "bmpfont.h"
#include "mysdl.h"
#include "mymath.h"

Message::Message(BMPFont* font, const std::string& msg,
				 Num x, Num y, Num sx, Num sy, bool flash)
	: Charactor::HaveSpeed(x, y, sx, sy), turn_(0), flash_(flash)
{
	bmp_[0] = MySDL_CreateRGBSurface(
		SDL_SWSURFACE, font->width(msg.length()), font->height(), 8);
	bmp_[0] = MySDL_DisplayFormat(bmp_[0]);
	MySDL_SetColorKey(bmp_[0], SDL_SRCCOLORKEY|SDL_RLEACCEL, 0,0,0);
	font->render(msg.c_str(), bmp_[0], 0, 0);

	if (flash_) {
		for (int i = 1; i < FLASH_COLORS; i++) {
			bmp_[i] = MySDL_CreateRGBSurface(
				SDL_SWSURFACE, font->width(msg.length()), font->height(), 8);
			bmp_[i] = MySDL_DisplayFormat(bmp_[i]);
			MySDL_SetColorKey(bmp_[i], SDL_SRCCOLORKEY|SDL_RLEACCEL, 0,0,0);
			font->render(msg.c_str(), bmp_[i], 0, 0);
			MySDL_ChangeColor(bmp_[i], 255-i);
		}
	}
}

Message::~Message() {
	SDL_FreeSurface(bmp_[0]);
	if (flash_) {
		for (int i = 1; i < FLASH_COLORS; i++) SDL_FreeSurface(bmp_[i]);
	}
}

void Message::render(SDL_Surface* dstSurf) {
	if (flash_) {
		MySDL_BlitSurface(bmp_[rnd(FLASH_COLORS)], dstSurf, xi(), yi());
	}
	else {
		MySDL_BlitSurface(bmp_[0], dstSurf, xi(), yi());
	}
}

