/**
 * $Id: message.h,v 1.2 2003/03/30 03:37:35 i Exp $
 *
 * Copyright (C) shinichiro.h <g940455@mail.ecc.u-tokyo.ac.jp>
 *  http://user.ecc.u-tokyo.ac.jp/~g940455/wp/
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef message_h_
#define message_h_

#include "charactor.h"

#include <string>

class Message : public Charactor::HaveSpeed {
public:
	Message(class BMPFont* font, const std::string& msg,
			Num x, Num y, Num sx, Num sy, bool flash = false);
	~Message();

	void render(struct SDL_Surface* dstSurf);

	// ۴ؿǤ̵ɾ񤭡
	void move() {
		turn_++;
		Charactor::HaveSpeed::move();
	}

	int getTurn() const { return turn_; }

private:
	static const int FLASH_COLORS = 3;

	class BMPFont* font_;
	struct SDL_Surface* bmp_[FLASH_COLORS];
	int turn_;
	bool flash_;

};

#endif // ! message_h_

