/**
 * $Id: mysdl.h,v 1.2 2003/03/30 03:37:35 i Exp $
 *
 * Copyright (C) shinichiro.h <g940455@mail.ecc.u-tokyo.ac.jp>
 *  http://user.ecc.u-tokyo.ac.jp/~g940455/wp/
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef mysdl_h_
#define mysdl_h_

#include <SDL.h>

inline SDL_Surface*
MySDL_CreateRGBSurface(Uint32 flags, Uint32 w, Uint32 h, Uint32 bpp) {
	return SDL_CreateRGBSurface(flags, w, h, bpp, 0,0,0,0);
}

inline void
MySDL_BlitSurface(SDL_Surface* src, int sx, int sy, int sw, int sh,
				  SDL_Surface* dst, int dx, int dy) {
	SDL_Rect srcRect, dstRect;
	srcRect.x = sx; srcRect.y = sy; srcRect.w = sw; srcRect.h = sh;
	dstRect.x = dx; dstRect.y = dy;
	SDL_BlitSurface(src, &srcRect, dst, &dstRect);
}

inline void
MySDL_BlitSurface(SDL_Surface* src, SDL_Surface* dst, int x, int y) {
	SDL_Rect dstRect;
	dstRect.x = x; dstRect.y = y;
	SDL_BlitSurface(src, 0, dst, &dstRect);
}

void MySDL_ChangeColor(SDL_Surface* surf, Uint32 to);

inline void MySDL_BlitSurface(SDL_Surface* src, SDL_Surface* dst) {
	SDL_BlitSurface(src, 0, dst, 0);
}

inline void MySDL_SetColorKey(SDL_Surface* surf, Uint32 flags,
							  Uint8 r, Uint8 g, Uint8 b)
{
	SDL_SetColorKey(surf, flags, SDL_MapRGB(surf->format, r, g, b));
}

inline SDL_Surface* MySDL_DisplayFormat(SDL_Surface* src) {
	SDL_Surface* dst = SDL_DisplayFormat(src);
	SDL_FreeSurface(src);
	return dst;
}

inline SDL_Surface* MySDL_LoadBMP(const char* file) {
	return MySDL_DisplayFormat(SDL_LoadBMP(file));
}

inline SDL_Color MySDL_Color(Uint8 r, Uint8 g, Uint8 b, Uint8 a = 255) {
	SDL_Color ret;
	ret.r = r;
	ret.g = g;
	ret.b = b;
	ret.unused = a;
	return ret;
}

#endif // ! mysdl_h_

