#include "player.h"
#include "padinput.h"
#include "mymath.h"
#include "bpo.h"
#include "resource.h"

#include <SDL.h>

Player::Player(InputBase* input)
	: input_(input), invisible_(0)
{
	playerSpeed_ = BPO::rc().get<double>("playerSpeed");
	playerSpeed2_ = BPO::rc().get<double>("playerSpeed2");

	invisibleMax_ = BPO::rc().get<int>("playerInvisibleTurn");
}

void Player::move() {
	invisible_--;

	SDL_PumpEvents();

	double base;

	button_ = input_->getButton(0);
	axis_ = input_->getAxis();

	if (button_) base = playerSpeed2_;
	else base = playerSpeed_;
	double cross = base / SQRT_2;

	if (axis_ == Axis::UP) y_ -= base;
	else if (axis_ == Axis::RIGHT) x_ += base;
	else if (axis_ == Axis::DOWN) y_ += base;
	else if (axis_ == Axis::LEFT) x_ -= base;
	else if (axis_ == Axis::UPRIGHT) {
		x_ += cross;
		y_ -= cross;
	}
	else if (axis_ == Axis::DOWNRIGHT) {
		x_ += cross;
		y_ += cross;
	}
	else if (axis_ == Axis::DOWNLEFT) {
		x_ -= cross;
		y_ += cross;
	}
	else if (axis_ == Axis::UPLEFT) {
		x_ -= cross;
		y_ -= cross;
	}

}
