/**
 * $Id: player.h,v 1.6 2003/03/30 03:37:35 i Exp $
 *
 * Copyright (C) shinichiro.h <g940455@mail.ecc.u-tokyo.ac.jp>
 *  http://user.ecc.u-tokyo.ac.jp/~g940455/wp/
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef player_h_
#define player_h_

#include "charactor.h"

#include "padinput.h"

class Player : public Charactor::HavePoint {
public:
	explicit Player(InputBase* input);

	void move();

	void setInvisible() {
		invisible_ = invisibleMax_;
	}
	bool isInvisible() const {
		return invisible_ > 0;
	}

	bool button() const { return button_; }
	Axis axis() const { return axis_; }

private:
	class InputBase* input_;

	double playerSpeed_;
	double playerSpeed2_;

	int invisibleMax_;
	int invisible_;

	bool button_;
	Axis axis_;
};

#endif // ! player_h_



