/**
 * $Id: scene.h,v 1.5 2003/04/06 13:34:57 i Exp $
 *
 * Copyright (C) shinichiro.h <g940455@mail.ecc.u-tokyo.ac.jp>
 *  http://user.ecc.u-tokyo.ac.jp/~g940455/wp/
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef scene_h_
#define scene_h_

#include <memory>

class Scene {
public:
	virtual bool isEnd() const =0;
	virtual std::auto_ptr<Scene> getNext() =0;
	virtual std::auto_ptr<Scene> getEscapedNext();
	virtual void run() =0;

	virtual ~Scene() {}
};

class Game;

/// $B8_$$$N(B scene $B$rCN$i$J$$$H$$$&$3$H$r<B8=$9$k$?$a$@$1$I!D(B
namespace SceneFactory {
	std::auto_ptr<Scene> generateTitle();
	std::auto_ptr<Scene> generateSelect();
	std::auto_ptr<Scene> generateGame();
	std::auto_ptr<Scene> generateResult(Game* game);
	std::auto_ptr<Scene> generateHighscore();
	std::auto_ptr<Scene> generateEnd();
}

#endif // ! scene_h_
