/**
 * $Id: scene_game.cc,v 1.4 2003/03/30 03:37:35 i Exp $
 *
 * Copyright (C) shinichiro.h <g940455@mail.ecc.u-tokyo.ac.jp>
 *  http://user.ecc.u-tokyo.ac.jp/~g940455/wp/
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include "scene_game.h"

#include "game.h"
#include "bpo.h"
#include "padinput.h"

#include <SDL.h>

SceneGame::SceneGame()
	: game_(new Game())
{}

bool SceneGame::isEnd() const {
    return game_->isEnd();
}

std::auto_ptr<Scene> SceneGame::getNext() {
	while (BPO::getInput()->getButton(0)) SDL_PumpEvents();
    return SceneFactory::generateResult(game_.get());
}

std::auto_ptr<Scene> SceneGame::getEscapedNext() {
	return SceneFactory::generateResult(game_.get());
}

void SceneGame::run() {
	game_->run();
}

