/**
 * $Id: scene_result.h,v 1.3 2003/04/06 13:34:57 i Exp $
 *
 * Copyright (C) shinichiro.h <g940455@mail.ecc.u-tokyo.ac.jp>
 *  http://user.ecc.u-tokyo.ac.jp/~g940455/wp/
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef scene_result_h_
#define scene_result_h_

#include "scene.h"

#include <memory>
#include <string>

class SceneResult : public Scene {
public:
	SceneResult(std::auto_ptr<class Resource> result,
				std::auto_ptr<class BonusMgr> bonus,
				std::auto_ptr<class Music> music);
	virtual ~SceneResult();
	static std::auto_ptr<Scene> createFromHighscore();

	virtual bool isEnd() const;
	virtual std::auto_ptr<Scene> getNext();
	virtual void run();

private:
	void renderCenter(std::string str, int h);
	void renderLeft(std::string str, int h);
	void renderRight(std::string str, int h);

private:
	std::auto_ptr<class Resource> result_;
	std::auto_ptr<class BonusMgr> bonus_;
	std::auto_ptr<class Music> music_;

	struct SDL_Surface* scr_;
	class BMPFont* font_;

	int turn_;
	typedef enum { SCORE, MISC, END } State_;
	State_ state_;

	const int resultLeft_;
	const int resultUp_;
	const int resultRight_;
	const int resultSpace_;
};

#endif // ! scene_result_h_

