/**
 * $Id: scene_select.h,v 1.6 2003/04/09 03:09:25 i Exp $
 *
 * Copyright (C) shinichiro.h <g940455@mail.ecc.u-tokyo.ac.jp>
 *  http://user.ecc.u-tokyo.ac.jp/~g940455/wp/
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef scene_select_h_
#define scene_select_h_

#include "scene.h"

#include <string>
#include <vector>

class SceneSelect : public Scene {
public:
	SceneSelect();
	virtual ~SceneSelect();

	virtual bool isEnd() const;
	virtual std::auto_ptr<Scene> getNext();
	virtual void run();

private:
	void renderLeft(std::string str, size_t h);
	void renderRight(std::string str, size_t h);

private:
	struct Config_;
	std::vector<std::string> confNames_;
	std::vector<Config_*> confs_;
	std::vector<size_t> state_;

private:
	struct SDL_Surface* scr_;
	class BMPFont* font_;

	int turn_;
	int prevInputTurn_;

	size_t height_;

	bool end_;

	const int selectLeft_;
	const int selectUp_;
	const int selectRight_;
	const int selectSpace_;
};

#endif // ! scene_select_h_

