/**
 * $Id: scene_title.cc,v 1.6 2003/07/24 10:53:10 i Exp $
 *
 * Copyright (C) shinichiro.h <g940455@mail.ecc.u-tokyo.ac.jp>
 *  http://user.ecc.u-tokyo.ac.jp/~g940455/wp/
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include "scene_title.h"

#include "padinput.h"
#include "cpputil.h"
#include "mymath.h"
#include "mysdl.h"
#include "bpo.h"
#include "dir_ite.h"
#include "clear_screen.h"
#include "resource.h"

#include <SDL.h>

#include <boost/compose.hpp>

#include <algorithm>
#include <functional>

SceneTitle::SceneTitle()
	: turn_(0), end_(false), val_(0)
{
	title_ = MySDL_LoadBMP(("bmp/title_bttsoief_ttf_" +
							BPO::rc().get<std::string>("mode") +
							".bmp").c_str());
	check(title_ != 0, "bmp/title_bttsoief_ttf.bmp: not found");
}

SceneTitle::~SceneTitle() {
	SDL_FreeSurface(title_);
}

bool SceneTitle::isEnd() const {
    return end_;
}

std::auto_ptr<Scene> SceneTitle::getNext() {
    return SceneFactory::generateSelect();
}

void SceneTitle::run() {
	turn_++;

	InputBase* input = BPO::getInput();
	if (input->getButton(0) ||
		(BPO::rc().get<bool>("autoStart") && turn_ > 120))
	{
		end_ = true;
		while (input->getButton(0)) SDL_PumpEvents();
	}

	SDL_Surface* scr = BPO::getSurface();

	val_ = (val_ + rnd(5)) & 15;

	if (val_ < 5) {
		MySDL_BlitSurface(title_, scr,
						  (scr->w - title_->w) / 2 + rnd(2),
						  (scr->h - title_->h) / 2 + rnd(2));
	}
}


