/**
 * $Id: score.h,v 1.4 2003/03/30 03:37:35 i Exp $
 *
 * Copyright (C) shinichiro.h <g940455@mail.ecc.u-tokyo.ac.jp>
 *  http://user.ecc.u-tokyo.ac.jp/~g940455/wp/
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef score_h_
#define score_h_

class Score {
public:
	Score();
	~Score();

	void doBuzz();
	void doDamage();
	void setRank(int rank) { rank_ = rank; }
	void addBonus(int bonus) { score_ += bonus; }

	void draw();

	int score() const { return score_; }
	int buzz() const { return buzz_; }
	int maxBuzz() const { return maxBuzz_; }
	int buzzScore() const { return buzzScore_; }
	int buzzNum() const { return buzzNum_; }

private:
	int score_;
	int buzz_;
	int scorePerBuzz_;
	int maxBuzz_;
	int rank_;
	int buzzScore_;
	int buzzNum_;

	struct SDL_Surface* surf_;
	class BMPFont* font_;

	struct SDL_Surface* scoreSurf_;
	struct SDL_Surface* buzzSurf_;
	struct SDL_Surface* scorePerBuzzSurf_;
	struct SDL_Surface* rankSurf_;

private:
	const int drawScoreX_, drawScoreY_;
	const int drawBuzzX_, drawBuzzY_;
	const int drawBuzzScoreX_, drawBuzzScoreY_;
	const int drawRankX_, drawRankY_;
	const int drawTimeX_, drawTimeY_;
};

#endif // ! score_h_

