#include <vector>
#include <assert.h>

template <typename T_>
class size_checked_vector : public std::vector<T_> {
public:
	T_& operator[] (size_t n) {
		assert(n < size());
		return std::vector<T_>::operator[](n);
	}
	const T_& operator[] (size_t n) const {
		assert(n < size());
		return std::vector<T_>::operator[](n);
	}
};

